diff -ru openssh-3.7.1p2.orig/TODO openssh-3.7.1p2/TODO
--- openssh-3.7.1p2.orig/TODO	2003-06-11 23:56:41.000000000 +1000
+++ openssh-3.7.1p2/TODO	2003-09-24 06:45:13.000000000 +1000
@@ -30,8 +30,6 @@
 
 - More platforms for for setproctitle() emulation (testing needed)
 
-- Handle changing passwords for the non-PAM expired password case
-
 - Improve PAM support (a pam_lastlog module will cause sshd to exit)
   and maybe support alternate forms of authentications like OPIE via
   pam?
diff -ru openssh-3.7.1p2.orig/acconfig.h openssh-3.7.1p2/acconfig.h
--- openssh-3.7.1p2.orig/acconfig.h	2003-09-16 11:52:19.000000000 +1000
+++ openssh-3.7.1p2/acconfig.h	2003-09-24 06:45:13.000000000 +1000
@@ -59,6 +59,9 @@
 /* from environment and PATH */
 #undef LOGIN_PROGRAM_FALLBACK
 
+/* Path to passwd program */
+#undef PASSWD_PROGRAM_PATH
+
 /* Define if your password has a pw_class field */
 #undef HAVE_PW_CLASS_IN_PASSWD
 
diff -ru openssh-3.7.1p2.orig/auth-pam.c openssh-3.7.1p2/auth-pam.c
--- openssh-3.7.1p2.orig/auth-pam.c	2003-09-23 19:24:21.000000000 +1000
+++ openssh-3.7.1p2/auth-pam.c	2003-09-24 06:45:13.000000000 +1000
@@ -52,6 +52,7 @@
 #include "auth-options.h"
 
 extern ServerOptions options;
+extern int password_change_required;
 
 #define __unused
 
@@ -281,7 +282,7 @@
 		pam_close_session(sshpam_handle, PAM_SILENT);
 		sshpam_session_open = 0;
 	}
-	sshpam_authenticated = sshpam_new_authtok_reqd = 0;
+	sshpam_authenticated = password_change_required = 0;
 	pam_end(sshpam_handle, sshpam_err);
 	sshpam_handle = NULL;
 }
@@ -537,14 +538,8 @@
 	if (sshpam_err != PAM_SUCCESS && sshpam_err != PAM_NEW_AUTHTOK_REQD)
 		return (0);
 
-	if (sshpam_err == PAM_NEW_AUTHTOK_REQD) {
-		sshpam_new_authtok_reqd = 1;
-
-		/* Prevent forwardings until password changed */
-		no_port_forwarding_flag |= 2;
-		no_agent_forwarding_flag |= 2;
-		no_x11_forwarding_flag |= 2;
-	}
+	if (sshpam_err == PAM_NEW_AUTHTOK_REQD)
+		flag_password_change_required();
 
 	return (1);
 }
@@ -603,12 +598,6 @@
 		    pam_strerror(sshpam_handle, sshpam_err));
 }
 
-int
-is_pam_password_change_required(void)
-{
-	return (sshpam_new_authtok_reqd);
-}
-
 static int
 pam_chauthtok_conv(int n, const struct pam_message **msg,
     struct pam_response **resp, void *data)
@@ -685,6 +674,8 @@
 	if (sshpam_err != PAM_SUCCESS)
 		fatal("PAM: pam_chauthtok(): %s",
 		    pam_strerror(sshpam_handle, sshpam_err));
+	else
+		flag_password_change_successful();
 }
 
 /* 
diff -ru openssh-3.7.1p2.orig/auth-passwd.c openssh-3.7.1p2/auth-passwd.c
--- openssh-3.7.1p2.orig/auth-passwd.c	2003-09-18 18:26:48.000000000 +1000
+++ openssh-3.7.1p2/auth-passwd.c	2003-09-24 06:45:13.000000000 +1000
@@ -42,13 +42,17 @@
 #include "log.h"
 #include "servconf.h"
 #include "auth.h"
-#ifdef WITH_AIXAUTHENTICATE
-# include "buffer.h"
-# include "canohost.h"
-extern Buffer loginmsg;
-#endif
+#include "buffer.h"
+#include "canohost.h"
+#include "misc.h"
+#include "channels.h"
+#include "auth-options.h"
+#include "uidswap.h"
 
 extern ServerOptions options;
+extern Buffer loginmsg;
+
+int password_change_required = 0;
 
 /*
  * Tries to authenticate the user using password.  Returns true if
@@ -99,7 +103,6 @@
 
 		if (authenticate(pw->pw_name, password, &reenter,
 		    &authmsg) == 0 && ok) {
-			char *msg;
 			char *host = 
 			    (char *)get_canonical_hostname(options.use_dns);
 
@@ -107,19 +110,7 @@
 			aix_remove_embedded_newlines(authmsg);	
 
 			debug3("AIX/authenticate succeeded for user %s: %.100s",
-				pw->pw_name, authmsg);
-
-	        	/* No pty yet, so just label the line as "ssh" */
-			aix_setauthdb(authctxt->user);
-	        	if (loginsuccess(authctxt->user, host, "ssh", 
-			    &msg) == 0) {
-				if (msg != NULL) {
-					debug("%s: msg %s", __func__, msg);
-					buffer_append(&loginmsg, msg, 
-					    strlen(msg));
-					xfree(msg);
-				}
-			}
+			    pw->pw_name, authmsg);
 		} else {
 			debug3("AIX/authenticate failed for user %s: %.100s",
 			    pw->pw_name, authmsg);
@@ -161,3 +152,79 @@
 # endif
 #endif /* !HAVE_OSF_SIA */
 }
+
+/*
+ * Perform generic password change via tty. Like do_pam_chauthtok(),
+ * it throws a fatal error if the password can't be changed.
+ */
+int
+do_tty_change_password(struct passwd *pw)
+{
+	pid_t pid;
+	int status;
+	mysig_t old_signal;
+
+	old_signal = signal(SIGCHLD, SIG_DFL);
+
+	if ((pid = fork()) == -1)
+		fatal("Couldn't fork: %s", strerror(errno));
+
+	if (pid == 0) {
+		permanently_set_uid(pw);
+		if (geteuid() == 0) 
+			execl(PASSWD_PROGRAM_PATH, "passwd", pw->pw_name,
+			    (char *)NULL);
+		else
+			execl(PASSWD_PROGRAM_PATH, "passwd", (char *)NULL);
+			
+		/* execl shouldn't return */
+		fatal("Couldn't exec %s", PASSWD_PROGRAM_PATH);
+		exit(1);
+	}
+
+	debug3("%s: waiting for pid %d", __func__, (int)pid);
+	if (waitpid(pid, &status, 0) == -1)
+		fatal("Couldn't wait for child: %s", strerror(errno));
+	signal(SIGCHLD, old_signal);
+
+	if (WIFEXITED(status) && WEXITSTATUS(status) == 0) {
+		debug("%s password changed sucessfully", __func__);
+		flag_password_change_successful();
+		return 1;
+	} else {
+		fatal("Failed to change password for %s, passwd returned %d",
+		    pw->pw_name, status);
+		return 0;
+	}
+}
+
+/*
+ * flag that password change is necessary
+ */
+void
+flag_password_change_required(void)
+{
+	debug3("disabling forwarding");
+	password_change_required = 1;
+
+	/* disallow other functionality for now */
+	no_port_forwarding_flag |= 2;
+	no_agent_forwarding_flag |= 2;
+	no_x11_forwarding_flag |= 2;
+}
+
+/*
+ * password change successful
+ * XXX: must be done in parent, but currently there is no way to pass
+ * this request.
+ */
+void
+flag_password_change_successful(void)
+{
+	debug3("resetting forwarding flags");
+
+	password_change_required = 0;
+	no_port_forwarding_flag &= ~2;
+	no_agent_forwarding_flag &= ~2;
+	no_x11_forwarding_flag &= ~2;
+}
diff -ru openssh-3.7.1p2.orig/auth.c openssh-3.7.1p2/auth.c
--- openssh-3.7.1p2.orig/auth.c	2003-09-03 07:32:46.000000000 +1000
+++ openssh-3.7.1p2/auth.c	2003-09-24 06:45:13.000000000 +1000
@@ -36,6 +36,14 @@
 #include <libgen.h>
 #endif
 
+#ifdef WITH_AIXAUTHENTICATE
+#include <userpw.h>
+#include <usersec.h>
+# ifdef HAVE_SYS_AUDIT_H
+#  include <sys/audit.h>
+# endif
+#endif
+
 #include "xmalloc.h"
 #include "match.h"
 #include "groupaccess.h"
@@ -51,6 +59,7 @@
 #include "misc.h"
 #include "bufaux.h"
 #include "packet.h"
+#include "sshlogin.h"
 
 /* import */
 extern ServerOptions options;
@@ -59,6 +68,8 @@
 /* Debugging messages */
 Buffer auth_debug;
 int auth_debug_init;
+extern Buffer expiremsg;
+extern Buffer loginmsg;
 
 /*
  * Check if the user is allowed to log in via ssh. If user is listed
@@ -84,39 +95,67 @@
 	if (!pw || !pw->pw_name)
 		return 0;
 
+#define	DAY		(24L * 60 * 60) /* 1 day in seconds */
+#define WEEK		(DAY * 7)	/* 1 week in seconds */
 #if defined(HAVE_SHADOW_H) && !defined(DISABLE_SHADOW)
 	if (!options.use_pam)
 		spw = getspnam(pw->pw_name);
 #ifdef HAS_SHADOW_EXPIRE
-#define	DAY		(24L * 60 * 60) /* 1 day in seconds */
 	if (!options.use_pam && spw != NULL) {
 		time_t today;
+		int daysleft;
 
+	debug("%s: entering", __func__);
 		today = time(NULL) / DAY;
 		debug3("allowed_user: today %d sp_expire %d sp_lstchg %d"
-		    " sp_max %d", (int)today, (int)spw->sp_expire,
-		    (int)spw->sp_lstchg, (int)spw->sp_max);
+		    " sp_max %d sp_warn %d", (int)today, (int)spw->sp_expire,
+		    (int)spw->sp_lstchg, (int)spw->sp_max, (int)spw->sp_warn);
 
 		/*
 		 * We assume account and password expiration occurs the
 		 * day after the day specified.
 		 */
-		if (spw->sp_expire != -1 && today > spw->sp_expire) {
+		daysleft = spw->sp_expire - today;
+		if (spw->sp_expire == -1) {
+			debug3("account expiration disabled");
+		} else if (daysleft < 0) {
 			logit("Account %.100s has expired", pw->pw_name);
 			return 0;
+		} else if (daysleft <= spw->sp_warn) {
+			char buf[256];
+
+			debug3("account will expire in %d days", daysleft);
+			snprintf(buf, sizeof(buf),
+			    "Your account will expire in %d day%s.\n",
+			    daysleft, daysleft == 1 ? "" : "s");
+			buffer_append(&loginmsg, buf, strlen(buf));
 		}
 
+#define PWCHG_FORCED    "You must change your password now.\n"
+#define PWCHG_EXPIRED   "Your password has expired, you must change it now.\n"
+		daysleft = spw->sp_lstchg + spw->sp_max - today;
 		if (spw->sp_lstchg == 0) {
 			logit("User %.100s password has expired (root forced)",
 			    pw->pw_name);
-			return 0;
-		}
-
-		if (spw->sp_max != -1 &&
-		    today > spw->sp_lstchg + spw->sp_max) {
+			flag_password_change_required();
+			buffer_append(&expiremsg, PWCHG_FORCED,
+			    sizeof(PWCHG_FORCED));
+		} else if (spw->sp_max == -1) {
+			debug3("password expiration disabled");
+		} else if (daysleft < 0) {
 			logit("User %.100s password has expired (password aged)",
 			    pw->pw_name);
-			return 0;
+			flag_password_change_required();
+			buffer_append(&expiremsg, PWCHG_EXPIRED,
+			    sizeof(PWCHG_EXPIRED));
+		} else if (daysleft <= spw->sp_warn) {
+			char buf[256];
+
+			debug3("password will expire in %d days", daysleft);
+			snprintf(buf, sizeof(buf),
+			    "Your password will expire in %d day%s.\n",
+			    daysleft, daysleft == 1 ? "" : "s");
+			buffer_append(&expiremsg, buf, strlen(buf));
 		}
 	}
 #endif /* HAS_SHADOW_EXPIRE */
@@ -257,6 +296,64 @@
 				return 0;
 		}
 	}
+
+	/*
+	 * Check AIX password expiry.  Only check when running as root.
+	 * Unpriv'ed users can't access /etc/security/passwd or
+	 * /etc/security/user so passwdexpired will always fail.
+	 */
+	if (geteuid() == 0) {
+		char *msg, *user = pw->pw_name;
+		int result, maxage, result2, maxexpired;
+		struct userpw *upw;
+
+		/*
+		 * Check if password expired too long as in this case,
+		 * passwdexpired still returns 1 but /bin/passwd will fail
+		 */
+		upw = getuserpw(user);
+		result = getuserattr(user, S_MAXEXPIRED, &maxexpired, SEC_INT);
+		result2 = getuserattr(user, S_MAXAGE, &maxage, SEC_INT);
+		if (upw != NULL && result == 0 && result2 == 0) {
+			time_t now = time(NULL);
+
+			debug3("%s lastupdate %lu maxage %d wks maxexpired %d"
+			    "wks time now %d", __func__, 
+			    (unsigned long)upw->upw_lastupdate, maxage,
+			    maxexpired, now);
+
+			if (maxexpired != -1 && maxage != 0 &&
+			    upw->upw_lastupdate + ((maxage+maxexpired) * WEEK) <= now ) {
+				logit("User %.100s password expired too long",
+				    user);
+				return 0;
+			}
+		}
+
+		result = passwdexpired(user, &msg);
+		if (msg && *msg) {
+			buffer_append(&expiremsg, msg, strlen(msg));
+			aix_remove_embedded_newlines(msg);
+		}
+		debug3("AIX/passwdexpired returned %d msg %.100s", result, msg);
+
+		switch (result) {
+		case 0: /* success, password not expired */
+			break;
+		case 1: /* expired, password change required */
+			flag_password_change_required();
+			break;
+		default: /* user can't change(2) or other error (-1) */
+			logit("Password can't be changed for user %s: "
+			    "%.100s", user, msg);
+			if (msg)
+				xfree(msg);
+			return 0;
+		}
+		if (msg)
+			xfree(msg);
+
+	}
 #endif /* WITH_AIXAUTHENTICATE */
 
 	/* We found no reason not to let this user try to log on... */
@@ -271,6 +368,46 @@
 	return authctxt;
 }
 
+/*
+ * Generate last_login message and store for later display.  This must be
+ * called before login_login() is called and lastlog is updated.
+ */
+void
+generate_loginmsg(const char *user, uid_t uid, const char *host)
+{
+#ifdef WITH_AIXAUTHENTICATE
+	char *msg;
+
+	/* We don't have a pty yet, so just label the line as "ssh" */
+	aix_setauthdb(user);
+	if (loginsuccess(user, host, "ssh", &msg) >= 0)
+		buffer_append(&loginmsg, msg, strlen(msg));
+#elif !defined(NO_SSH_LASTLOG)
+	if (options.print_lastlog) {
+		char *time_string, lasthost[MAXHOSTNAMELEN], buf[256];
+		time_t last_login_time;
+
+		last_login_time = get_last_login_time(uid, user, lasthost,
+		   sizeof(lasthost));
+
+		if (last_login_time != 0) {
+		       time_string = ctime(&last_login_time);
+		       if (strchr(time_string, '\n'))
+			       *strchr(time_string, '\n') = 0;
+		       if (strcmp(lasthost, "") == 0)
+			       snprintf(buf, sizeof(buf),
+				   "Last login: %s\r\n",
+				   time_string);
+		       else
+			       snprintf(buf, sizeof(buf),
+				   "Last login: %s from %s\r\n",
+				   time_string, lasthost);
+		       buffer_append(&loginmsg, buf, strlen(buf));
+		}
+       }
+#endif
+}
+
 void
 auth_log(Authctxt *authctxt, int authenticated, char *method, char *info)
 {
@@ -298,6 +435,10 @@
 	    get_remote_port(),
 	    info);
 
+	if (authenticated && geteuid() == 0)
+		generate_loginmsg(authctxt->user, authctxt->pw->pw_uid,
+		    get_canonical_hostname(options.use_dns));
+
 #ifdef CUSTOM_FAILED_LOGIN
 	if (authenticated == 0 && strcmp(method, "password") == 0)
 		record_failed_login(authctxt->user, "ssh");
diff -ru openssh-3.7.1p2.orig/auth.h openssh-3.7.1p2/auth.h
--- openssh-3.7.1p2.orig/auth.h	2003-09-03 12:11:30.000000000 +1000
+++ openssh-3.7.1p2/auth.h	2003-09-24 06:45:13.000000000 +1000
@@ -144,6 +144,9 @@
 
 int	allowed_user(struct passwd *);
 struct passwd * getpwnamallow(const char *user);
+int	do_tty_change_password(struct passwd *pw);
+void	flag_password_change_required(void);
+void	flag_password_change_successful(void);
 
 char	*get_challenge(Authctxt *);
 int	verify_response(Authctxt *, const char *);
diff -ru openssh-3.7.1p2.orig/config.h.in openssh-3.7.1p2/config.h.in
--- openssh-3.7.1p2.orig/config.h.in	2003-09-23 19:55:07.000000000 +1000
+++ openssh-3.7.1p2/config.h.in	2003-09-24 06:51:44.000000000 +1000
@@ -60,6 +60,9 @@
 /* from environment and PATH */
 #undef LOGIN_PROGRAM_FALLBACK
 
+/* Path to passwd program */
+#undef PASSWD_PROGRAM_PATH
+
 /* Define if your password has a pw_class field */
 #undef HAVE_PW_CLASS_IN_PASSWD
 
diff -ru openssh-3.7.1p2.orig/configure.ac openssh-3.7.1p2/configure.ac
--- openssh-3.7.1p2.orig/configure.ac	2003-09-23 19:24:21.000000000 +1000
+++ openssh-3.7.1p2/configure.ac	2003-09-24 06:45:19.000000000 +1000
@@ -42,6 +42,13 @@
 	fi
 fi
 
+AC_PATH_PROG(PASSWD_PROGRAM_PATH, passwd)
+if test ! -z "$PASSWD_PROGRAM_PATH" ; then
+	AC_DEFINE_UNQUOTED(PASSWD_PROGRAM_PATH, "$PASSWD_PROGRAM_PATH")
+else
+	AC_MSG_ERROR([*** passwd command not found - check config.log ***])
+fi
+
 if test -z "$LD" ; then
 	LD=$CC
 fi
diff -ru openssh-3.7.1p2.orig/scp.0 openssh-3.7.1p2/scp.0
--- openssh-3.7.1p2.orig/scp.0	2003-09-23 19:55:16.000000000 +1000
+++ openssh-3.7.1p2/scp.0	2003-09-24 06:51:12.000000000 +1000
@@ -1,4 +1,4 @@
-SCP(1)                     OpenBSD Reference Manual                     SCP(1)
+SCP(1)                  System General Commands Manual                  SCP(1)
 
 NAME
      scp - secure copy (remote file copy program)
@@ -41,8 +41,8 @@
              about their progress.  This is helpful in debugging connection,
              authentication, and configuration problems.
 
-     -B      Selects batch mode (prevents asking for passwords or passphras-
-             es).
+     -B      Selects batch mode (prevents asking for passwords or
+             passphrases).
 
      -q      Disables the progress meter.
 
@@ -91,4 +91,4 @@
      Timo Rinne <tri@iki.fi> and
      Tatu Ylonen <ylo@cs.hut.fi>
 
-OpenBSD 3.4                   September 25, 1999                             2
+BSD                           September 25, 1999                           BSD
diff -ru openssh-3.7.1p2.orig/session.c openssh-3.7.1p2/session.c
--- openssh-3.7.1p2.orig/session.c	2003-09-23 18:59:08.000000000 +1000
+++ openssh-3.7.1p2/session.c	2003-09-24 06:45:19.000000000 +1000
@@ -94,6 +94,9 @@
 extern int startup_pipe;
 extern void destroy_sensitive_data(void);
 extern Buffer loginmsg;
+extern Buffer expiremsg;
+extern int password_change_required;
+
 
 /* original command from peer. */
 const char *original_command = NULL;
@@ -395,13 +398,12 @@
 	session_proctitle(s);
 
 #if defined(USE_PAM)
-	if (options.use_pam) {
+	if (options.use_pam)
 		do_pam_setcred(1);
-		if (is_pam_password_change_required())
-			packet_disconnect("Password change required but no "
-			    "TTY available");
-	}
 #endif /* USE_PAM */
+	if (password_change_required)
+		packet_disconnect("Password change required but no "
+		    "TTY available");
 
 	/* Fork the child. */
 	if ((pid = fork()) == 0) {
@@ -671,10 +673,10 @@
 void
 do_login(Session *s, const char *command)
 {
-	char *time_string;
 	socklen_t fromlen;
 	struct sockaddr_storage from;
 	struct passwd * pw = s->pw;
+	int password_changed = 0;
 	pid_t pid = getpid();
 
 	/*
@@ -698,25 +700,41 @@
 		    options.use_dns),
 		    (struct sockaddr *)&from, fromlen);
 
-#ifdef USE_PAM
 	/*
 	 * If password change is needed, do it now.
 	 * This needs to occur before the ~/.hushlogin check.
 	 */
-	if (options.use_pam && is_pam_password_change_required()) {
-		print_pam_messages();
-		do_pam_chauthtok();
+	buffer_append(&expiremsg, "\0", 1);
+	if (password_change_required) {
+		if (options.use_pam) {
+#ifdef USE_PAM
+			print_pam_messages();
+			if (use_privsep)
+				do_tty_change_password(pw);
+			else
+				do_pam_chauthtok();
+#endif
+		} else {
+			printf("%s", (char *)buffer_ptr(&expiremsg)),
+			fflush(stdout);
+			do_tty_change_password(pw);
+		}
+		password_changed = 1;	/* chauthtok will abort on failure */
 		/* XXX - signal [net] parent to enable forwardings */
 	}
-#endif
 
 	if (check_quietlogin(s, command))
 		return;
 
+	if (!password_changed) {
+		if (options.use_pam) {
 #ifdef USE_PAM
-	if (options.use_pam && !is_pam_password_change_required())
-		print_pam_messages();
-#endif /* USE_PAM */
+			print_pam_messages();
+#endif
+		} else {
+			printf("%s", (char *)buffer_ptr(&expiremsg));
+		}
+	}
 
 	/* display post-login message */
 	if (buffer_len(&loginmsg) > 0) {
@@ -725,19 +743,6 @@
 	}
 	buffer_free(&loginmsg);
 
-#ifndef NO_SSH_LASTLOG
-	if (options.print_lastlog && s->last_login_time != 0) {
-		time_string = ctime(&s->last_login_time);
-		if (strchr(time_string, '\n'))
-			*strchr(time_string, '\n') = 0;
-		if (strcmp(s->hostname, "") == 0)
-			printf("Last login: %s\r\n", time_string);
-		else
-			printf("Last login: %s from %s\r\n", time_string,
-			    s->hostname);
-	}
-#endif /* NO_SSH_LASTLOG */
-
 	do_motd();
 }
 
@@ -1621,12 +1626,6 @@
 		packet_disconnect("Protocol error: you already have a pty.");
 		return 0;
 	}
-	/* Get the time and hostname when the user last logged in. */
-	if (options.print_lastlog) {
-		s->hostname[0] = '\0';
-		s->last_login_time = get_last_login_time(s->pw->pw_uid,
-		    s->pw->pw_name, s->hostname, sizeof(s->hostname));
-	}
 
 	s->term = packet_get_string(&len);
 
diff -ru openssh-3.7.1p2.orig/session.h openssh-3.7.1p2/session.h
--- openssh-3.7.1p2.orig/session.h	2003-08-26 11:49:56.000000000 +1000
+++ openssh-3.7.1p2/session.h	2003-09-24 06:45:19.000000000 +1000
@@ -39,9 +39,6 @@
 	int	ptyfd, ttyfd, ptymaster;
 	u_int	row, col, xpixel, ypixel;
 	char	tty[TTYSZ];
-	/* last login */
-	char	hostname[MAXHOSTNAMELEN];
-	time_t	last_login_time;
 	/* X11 */
 	u_int	display_number;
 	char	*display;
diff -ru openssh-3.7.1p2.orig/sftp-server.0 openssh-3.7.1p2/sftp-server.0
--- openssh-3.7.1p2.orig/sftp-server.0	2003-09-23 19:55:18.000000000 +1000
+++ openssh-3.7.1p2/sftp-server.0	2003-09-24 06:51:15.000000000 +1000
@@ -1,4 +1,4 @@
-SFTP-SERVER(8)          OpenBSD System Manager's Manual         SFTP-SERVER(8)
+SFTP-SERVER(8)              System Manager's Manual             SFTP-SERVER(8)
 
 NAME
      sftp-server - SFTP server subsystem
@@ -8,14 +8,14 @@
 
 DESCRIPTION
      sftp-server is a program that speaks the server side of SFTP protocol to
-     stdout and expects client requests from stdin.  sftp-server is not in-
-     tended to be called directly, but from sshd(8) using the Subsystem op-
-     tion.  See sshd(8) for more information.
+     stdout and expects client requests from stdin.  sftp-server is not
+     intended to be called directly, but from sshd(8) using the Subsystem
+     option.  See sshd(8) for more information.
 
 SEE ALSO
      sftp(1), ssh(1), sshd(8)
 
-     T. Ylonen, and S. Lehtinen, SSH File Transfer Protocol, draft-ietf-secsh-
+     T. Ylonen and S. Lehtinen, SSH File Transfer Protocol, draft-ietf-secsh-
      filexfer-00.txt, January 2001, work in progress material.
 
 AUTHORS
@@ -24,4 +24,4 @@
 HISTORY
      sftp-server first appeared in OpenBSD 2.8 .
 
-OpenBSD 3.4                     August 30, 2000                              1
+BSD                             August 30, 2000                            BSD
diff -ru openssh-3.7.1p2.orig/sftp.0 openssh-3.7.1p2/sftp.0
--- openssh-3.7.1p2.orig/sftp.0	2003-09-23 19:55:18.000000000 +1000
+++ openssh-3.7.1p2/sftp.0	2003-09-24 06:51:16.000000000 +1000
@@ -1,4 +1,4 @@
-SFTP(1)                    OpenBSD Reference Manual                    SFTP(1)
+SFTP(1)                 System General Commands Manual                 SFTP(1)
 
 NAME
      sftp - secure file transfer program
@@ -15,8 +15,8 @@
      sftp is an interactive file transfer program, similar to ftp(1), which
      performs all operations over an encrypted ssh(1) transport.  It may also
      use many features of ssh, such as public key authentication and compres-
-     sion.  sftp connects and logs into the specified host, then enters an in-
-     teractive command mode.
+     sion.  sftp connects and logs into the specified host, then enters an
+     interactive command mode.
 
      The second usage format will retrieve files automatically if a non-inter-
      active authentication method is used; otherwise it will do so after suc-
@@ -31,8 +31,8 @@
      sshd(8) and ssh-keygen(1) for details).  The options are as follows:
 
      -b batchfile
-             Batch mode reads a series of commands from an input batchfile in-
-             stead of stdin.  Since it lacks user interaction it should be
+             Batch mode reads a series of commands from an input batchfile
+             instead of stdin.  Since it lacks user interaction it should be
              used in conjunction with non-interactive authentication.  sftp
              will abort if any of the following commands fail: get, put,
              rename, ln, rm, mkdir, chdir, ls, lchdir, chmod, chown, chgrp,
@@ -82,8 +82,8 @@
 
 INTERACTIVE COMMANDS
      Once in interactive mode, sftp understands a set of commands similar to
-     those of ftp(1).  Commands are case insensitive and pathnames may be en-
-     closed in quotes if they contain spaces.
+     those of ftp(1).  Commands are case insensitive and pathnames may be
+     enclosed in quotes if they contain spaces.
 
      bye     Quit sftp.
 
@@ -140,9 +140,9 @@
              Toggle display of progress meter.
 
      put [flags] local-path [remote-path]
-             Upload local-path and store it on the remote machine.  If the re-
-             mote path name is not specified, it is given the same name it has
-             on the local machine.  If the -P flag is specified, then the
+             Upload local-path and store it on the remote machine.  If the
+             remote path name is not specified, it is given the same name it
+             has on the local machine.  If the -P flag is specified, then the
              file's full permission and access time are copied too.
 
      pwd     Display remote working directory.
@@ -175,7 +175,7 @@
      scp(1), ssh(1), ssh-add(1), ssh-keygen(1), ssh_config(5), sftp-server(8),
      sshd(8)
 
-     T. Ylonen, and S. Lehtinen, SSH File Transfer Protocol, draft-ietf-secsh-
+     T. Ylonen and S. Lehtinen, SSH File Transfer Protocol, draft-ietf-secsh-
      filexfer-00.txt, January 2001, work in progress material.
 
-OpenBSD 3.4                    February 4, 2001                              3
+BSD                            February 4, 2001                            BSD
diff -ru openssh-3.7.1p2.orig/ssh-add.0 openssh-3.7.1p2/ssh-add.0
--- openssh-3.7.1p2.orig/ssh-add.0	2003-09-23 19:55:16.000000000 +1000
+++ openssh-3.7.1p2/ssh-add.0	2003-09-24 06:51:12.000000000 +1000
@@ -1,4 +1,4 @@
-SSH-ADD(1)                 OpenBSD Reference Manual                 SSH-ADD(1)
+SSH-ADD(1)              System General Commands Manual              SSH-ADD(1)
 
 NAME
      ssh-add - adds RSA or DSA identities to the authentication agent
@@ -9,8 +9,8 @@
      ssh-add -e reader
 
 DESCRIPTION
-     ssh-add adds RSA or DSA identities to the authentication agent, ssh-
-     agent(1).  When run without arguments, it adds the files
+     ssh-add adds RSA or DSA identities to the authentication agent,
+     ssh-agent(1).  When run without arguments, it adds the files
      $HOME/.ssh/id_rsa, $HOME/.ssh/id_dsa and $HOME/.ssh/identity.  Alterna-
      tive file names can be given on the command line.  If any file requires a
      passphrase, ssh-add asks for the passphrase from the user.  The
@@ -99,4 +99,4 @@
      ated OpenSSH.  Markus Friedl contributed the support for SSH protocol
      versions 1.5 and 2.0.
 
-OpenBSD 3.4                   September 25, 1999                             2
+BSD                           September 25, 1999                           BSD
diff -ru openssh-3.7.1p2.orig/ssh-agent.0 openssh-3.7.1p2/ssh-agent.0
--- openssh-3.7.1p2.orig/ssh-agent.0	2003-09-23 19:55:16.000000000 +1000
+++ openssh-3.7.1p2/ssh-agent.0	2003-09-24 06:51:12.000000000 +1000
@@ -1,4 +1,4 @@
-SSH-AGENT(1)               OpenBSD Reference Manual               SSH-AGENT(1)
+SSH-AGENT(1)            System General Commands Manual            SSH-AGENT(1)
 
 NAME
      ssh-agent - authentication agent
@@ -18,8 +18,8 @@
      The options are as follows:
 
      -a bind_address
-             Bind the agent to the unix-domain socket bind_address.  The de-
-             fault is /tmp/ssh-XXXXXXXX/agent.<ppid>.
+             Bind the agent to the unix-domain socket bind_address.  The
+             default is /tmp/ssh-XXXXXXXX/agent.<ppid>.
 
      -c      Generate C-shell commands on stdout.  This is the default if
              SHELL looks like it's a csh style of shell.
@@ -34,8 +34,8 @@
              Set a default value for the maximum lifetime of identities added
              to the agent.  The lifetime may be specified in seconds or in a
              time format specified in sshd(8).  A lifetime specified for an
-             identity with ssh-add(1) overrides this value.  Without this op-
-             tion the default maximum lifetime is forever.
+             identity with ssh-add(1) overrides this value.  Without this
+             option the default maximum lifetime is forever.
 
      -d      Debug mode.  When this option is specified ssh-agent will not
              fork.
@@ -67,15 +67,15 @@
      looks at these variables and uses them to establish a connection to the
      agent.
 
-     The agent will never send a private key over its request channel.  In-
-     stead, operations that require a private key will be performed by the
+     The agent will never send a private key over its request channel.
+     Instead, operations that require a private key will be performed by the
      agent, and the result will be returned to the requester.  This way, pri-
      vate keys are not exposed to clients using the agent.
 
      A unix-domain socket is created and the name of this socket is stored in
      the SSH_AUTH_SOCK environment variable.  The socket is made accessible
-     only to the current user.  This method is easily abused by root or anoth-
-     er instance of the same user.
+     only to the current user.  This method is easily abused by root or
+     another instance of the same user.
 
      The SSH_AGENT_PID environment variable holds the agent's process ID.
 
@@ -111,4 +111,4 @@
      ated OpenSSH.  Markus Friedl contributed the support for SSH protocol
      versions 1.5 and 2.0.
 
-OpenBSD 3.4                   September 25, 1999                             2
+BSD                           September 25, 1999                           BSD
